package com.miui.deviceid;

import android.content.Context;
import android.util.Log;
import java.lang.reflect.Method;

public class IdentifierManager {
   private static final String TAG = "IdentifierManager";
   private static Object sIdProivderImpl;
   private static Class<?> sClass;
   private static Method sGetUDID = null;
   private static Method sGetOAID = null;
   private static Method sGetVAID = null;
   private static Method sGetAAID = null;

   public IdentifierManager() {
   }

   public static boolean isSupported() {
      return sClass != null && sIdProivderImpl != null;
   }

   public static String getUDID(Context context) {
      return invokeMethod(context, sGetUDID);
   }

   public static String getOAID(Context context) {
      return invokeMethod(context, sGetOAID);
   }

   public static String getVAID(Context context) {
      return invokeMethod(context, sGetVAID);
   }

   public static String getAAID(Context context) {
      return invokeMethod(context, sGetAAID);
   }

   private static String invokeMethod(Context context, Method method) {
      if (sIdProivderImpl != null && method != null) {
         try {
            Object result = method.invoke(sIdProivderImpl, context);
            if (result != null) {
               return (String)result;
            }
         } catch (Exception var3) {
            Log.e("IdentifierManager", "invoke exception!", var3);
         }
      }

      return null;
   }

   static {
      try {
         sClass = Class.forName("com.android.id.impl.IdProviderImpl");
         sIdProivderImpl = sClass.newInstance();
         sGetUDID = sClass.getMethod("getUDID", Context.class);
         sGetOAID = sClass.getMethod("getOAID", Context.class);
         sGetVAID = sClass.getMethod("getVAID", Context.class);
         sGetAAID = sClass.getMethod("getAAID", Context.class);
      } catch (Exception var1) {
         Log.e("IdentifierManager", "reflect exception!", var1);
      }

   }
}
